import QtQuick 2.0

Rectangle {
    width: 60
    height: 60
    property int xcoordinate: index % GameEngine.gameAreaX()
    property int ycoordinate: Math.floor(index / GameEngine.gameAreaX())
    color: (GameEngine.getMyAreaAt(xcoordinate,ycoordinate) === 1 ? "red" : GameEngine.getMyAreaAt(xcoordinate,ycoordinate) === 2 ? "black" : GameEngine.getMyAreaAt(xcoordinate,ycoordinate) === 3 ? "green" : "transparent")
    border.color: "white"
    border.width: 1
    opacity: GameEngine.getMyAreaAt(xcoordinate,ycoordinate) < 1 ? 0.1 : 0.5
    radius: 0

    property string hittype
    property int player: GameEngine.getIActivePlayer();

    MouseArea {
        anchors.fill: parent
        onClicked: {

            if(GameEngine.getGameState() === 2 ) {
                if(GameEngine.placeShip(page.activename,xcoordinate,0,ycoordinate,0) === 0) {
                    page.active.x = parent.x
                    page.active.y = parent.y
                    console.log(page.activename + " coords:" + xcoordinate + "," + ycoordinate + " direction:" + GameEngine.getShipDirection(page.activename))
                    console.log(GameEngine.getShipType(page.activename) + ": " + GameEngine.getShipX(page.activename) + "," + GameEngine.getShipY(page.activename))
                    infotext.text = "Player" + GameEngine.getIActivePlayer() + " at game state: " + GameEngine.getGameStateString(GameEngine.getGameState()) + ", shot " + GameEngine.getPlayerShot() + "/3"
                    labeltext.text = page.activename  + " A:" +  GameEngine.getShipArmor(page.activename) + " (" + GameEngine.getShipX(page.activename) + "," + GameEngine.getShipY(page.activename) + ") w1: " + GameEngine.getShipWeapon1(page.activename) + " w2:" + GameEngine.getShipWeapon2(page.activename)
                }
                else console.log("cannot set to" + xcoordinate + ", " + ycoordinate)
            }
            if(GameEngine.getGameState() === 3 ) {
                switch (GameEngine.getMyAreaAt(xcoordinate,ycoordinate)) {
                case 0:
                case 1:
                case 2:
                case 3:
                    break;
                }
            }
        }
    }
    onColorChanged: {
        number.text = ""
    }

    Connections {
         target: GameEngine
    }

    Text {
        id: number
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        text: ""
    }
}
