import QtQuick 2.0

Rectangle {
    width: childrenRect.width
    height: childrenRect.height
    x: GameEngine.getShipX(name)*boxsize
    y: GameEngine.getShipY(name)*boxsize
    color: "transparent"
    rotation: battleship.rotation
    border.width: 5
    border.color: activename === name ? "green" : "transparent"
    property string name
    Image {
        id: battleship
        source: "../pics/" + GameEngine.getShipImage(parent.name)
        width: GameEngine.getShipLength(parent.name)*boxsize
        height: boxsize
        rotation: 0
        onRotationChanged: {
            console.log( parent.name + " my r: " + battleship.rotation + " x:" + battleship.x + " y: " + battleship.y)
        }

    }

    onRotationChanged: {
        labeltext.text = "w:" + width + " h:" + height + " x:" + battleship.x + " y: " + battleship.y + " r:" + battleship.rotation
        /*var w = parent.width
        var h = parent.height
        parent.width = h
        parent.height = w
        battleship.rotation = rotation
        battleship.height = w
        battleship.width = h*/
        //battleship.rotation = rotation
        console.log( name + " parent r:" + page.active.rotation + " x:" + page.active.x + " y: " + page.active.y)
        console.log( name + " parent r:" + page.active.rotation + " x:" + page.active.x + " y: " + page.active.y)

    }
    //onParentChanged: labeltext.text = "w:" + width + " h:" + height + " x:" + battleship.x + " y: " + battleship.y + " r:" + battleship.rotation

    MouseArea {
        anchors.fill: parent
        onClicked: {
            if(GameEngine.getGameState() === 2 ) labeltext.text = parent.name  + " A:" +  GameEngine.getShipArmor(parent.name) + " (" +
                                                 GameEngine.getShipX(parent.name) + "," + GameEngine.getShipY(parent.name) + ") w1: " +
                                                 GameEngine.getShipWeapon1(page.activename) + " w2:" + GameEngine.getShipWeapon2(page.activename)
            else labeltext.text = parent.name  + " A:" +  GameEngine.getShipArmor(parent.name) + " (" + GameEngine.getShipX(parent.name) + "," +
                 GameEngine.getShipY(parent.name) + ") Selected: " + (weapon === 1 ? GameEngine.getShipWeapon1(parent.name) : weapon === 2 ?
                 GameEngine.getShipWeapon2(parent.name) : "none selected")
            if(GameEngine.getShipArmor(parent.name) > 0) {
                active = parent
                GameEngine.setActiveShip(parent.name)
                activename = parent.name
            }
            else labeltext.text = "INCAPACITED: " + labeltext.text
            console.log("Coordinates: " + GameEngine.getShipX(parent.name) + "," + GameEngine.getShipY(parent.name))
        }
        onDoubleClicked: {
            labeltext.text = "Ship double"
        }
    }
}
