import QtQuick 2.0

Rectangle {
    width: 60
    height: 60
    property int xcoordinate: index % GameEngine.gameAreaX()
    property int ycoordinate: Math.floor(index / GameEngine.gameAreaX())
    color: (GameEngine.getAreaAt(xcoordinate,ycoordinate) === 1 ? "red" : GameEngine.getAreaAt(xcoordinate,ycoordinate) === 2 ? "black" : GameEngine.getAreaAt(xcoordinate,ycoordinate) === 3 ? "green" : "transparent")
    border.color: "white"
    border.width: 1
    opacity: GameEngine.getAreaAt(xcoordinate,ycoordinate) < 1 ? 0.1 : 0.5
    radius: 0

    property string hittype: ""
    property string weapon: ""
    property int player: GameEngine.getIActivePlayer();

    MouseArea {
        anchors.fill: parent
        onClicked: {

            //number.text = index
            if( shot === false)
            {
                if(GameEngine.getGameState() === 2 ) {
                    if(GameEngine.placeShip(page.activename,xcoordinate,0,ycoordinate,0)) {
                        page.active.x = parent.x
                        page.active.y = parent.y
                        console.log(page.activename + " coords:" + xcoordinate + "," + ycoordinate + " direction:" + GameEngine.getShipDirection(page.activename))
                        console.log(GameEngine.getShipType(page.activename) + ": " + GameEngine.getShipX(page.activename) + "," + GameEngine.getShipY(page.activename))
                        infotext2.text = "Player" + GameEngine.getIActivePlayer() + " at game state: " + GameEngine.getGameStateString(GameEngine.getGameState()) + ", shot " + GameEngine.getPlayerShot() + "/3"
                    }
                }
                if(GameEngine.getGameState() === 3 ) {
                    weapon = GameEngine.getShipActiveWeapon(GameEngine.getActiveShip())
                    hittype = GameEngine.placeShot(xcoordinate,ycoordinate,GameEngine.getActiveShip(),GameEngine.getActiveWeapon());

                    infotext2.text = "P" + player + "shot at " + xcoordinate + "," + ycoordinate + " ... " + hittype + " with " + weapon
                    if(hittype === "HIT") parent.color = "red"
                    if(hittype === "MISS") parent.color = "green"
                    if(hittype === "DESTROYED") parent.color = "black"
                    parent.opacity = 0.5
                    shot = true

                    if(GameEngine.getIActivePlayer() === player) {
                        if(GameEngine.getGameState() === 4) {
                            changeplayertimer.running = true
                        }
                        else {
                            gobacktimer.running = true
                        }
                    }
                    else {
                        changeplayertimer.running = true
                    }
                }
                if(GameEngine.getGameState() === 4) {
                    changeplayertimer.running = true
                }
            }
        }
    }
    onColorChanged: {
        number.text = ""
    }

    Connections {
         target: GameEngine
    }

    Text {
        id: number
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        text: ""
    }

}
